Object.defineProperty(exports, "__esModule", { value: true });
exports.ResizableTable = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const antd_1 = require("antd");
const react_resizable_1 = require("react-resizable");
require("./style.css");
const ResizeableTitle = ({ onResize, width, ...restProps }) => {
    if (!width) {
        return react_1.default.createElement("th", { ...restProps });
    }
    return (react_1.default.createElement(react_resizable_1.Resizable, { width: width, height: 0, onResize: onResize, draggableOpts: { enableUserSelectHack: false }, minConstraints: [80, 80] },
        react_1.default.createElement("th", { ...restProps })));
};
class ResizableTable extends react_1.default.Component {
    state = {
        columns: [],
    };
    componentDidMount() {
        this.setState({
            columns: this.props.columns,
        });
    }
    components = {
        header: {
            cell: ResizeableTitle,
        },
    };
    handleResize = (index) => (_e, { size }) => {
        this.setState(({ columns }) => {
            const nextColumns = [...columns];
            const indexArr = index.split('-');
            const parentColumn = nextColumns[Number(indexArr[0])];
            if (indexArr[1]) {
                const childrenColumn = parentColumn.children[Number(indexArr[1])];
                childrenColumn.width = size.width;
            }
            parentColumn.width = size.width;
            return { columns: nextColumns };
        });
    };
    columnChildrenHandler = (children, parentIndex) => children.map((child, index) => ({
        ...child,
        onHeaderCell: (column) => ({
            width: column.width,
            onResize: this.handleResize(`${parentIndex}-${index}`),
        }),
    }));
    render() {
        const columns = this.state.columns.map((col, index) => ({
            ...col,
            children: col.children
                ? this.columnChildrenHandler(col.children, index)
                : [],
            onHeaderCell: (column) => ({
                width: column.width,
                onResize: this.handleResize(String(index)),
            }),
        }));
        return react_1.default.createElement(antd_1.Table, { ...this.props, components: this.components, columns: columns });
    }
}
exports.ResizableTable = ResizableTable;
